<?php
/*******************************************************************************
Ce fichier contient la dfinition des tables de la base de donnes.

notes sur les donnes de ce fichier :
le commentaire de la table est celui que porte la table dans la base de donnes.
cela n'a rien  voir avec le commentaire affich  l'cran qui est plus court,
voir pour cela le fichier dbComment.inc qui contient aussi la description des champs.
*******************************************************************************/
/*--------------------------------------------------------------------------------
Liste des paramtres du tableau dicTable[P1][P2] :
P1 : nom de la table
P2 :
-	 comment				: commentaire, description de la table
-	 descField				: champ descriptif des enregistrements (utile pour les rfrences) peut tre array
-	 shortDescField			: champ descriptif des enregistrements (utile pour les rfrences) peut tre array
-	 //fields[nom_du_champ]	: liste des champs de la table (rcup par SQL "show fields from TABLE ;")
-	 //primaryKey			: liste des champs cl primaire (idem)
-	 requestFields			: liste des champs obligatoires dans la table
-	 standardOrderBy		: liste des champs de tri standard ; peut tre array

--------------------------------------------------------------------------------
les cl trangres sont dfinies dans dbReferences 
*******************************************************************************/

$DIC_TablesList=array('event', 'user', 'classroom', 'workCenter', 'classe');
$DB_TablesNames=array('incident', 'utilisateur', 'salle', 'poste', 'classe');
$DB_ParmsTables=array('classroom', 'eventType', 'level');
$DB_ParmsTablesNames=array("Salles", "Types d'&eacute;v&egrave;nements", "Niveaux des utilisateurs");

/*--------------------------------------------------------------------------------
Liste des paramtres du tableau DIC_Table[P1][P2] :
P1 : nom de la table
P2 :
-	 name				: nom de la table
-	 comment				: commentaire, description de la table
-	 descField				: champ descriptif des enregistrements (utile pour les rfrences) peut tre array
-	 shortDescField			: champ descriptif des enregistrements (utile pour les rfrences) peut tre array
-	 //fields[nom_du_champ]	: liste des champs de la table (rcup par SQL "show fields from TABLE ;")
-	 //primaryKey			: liste des champs cl primaire (idem)
-	 requestFields			: liste des champs obligatoires dans la table
-	 standardOrderBy		: liste des champs de tri standard ; peut tre array

--------------------------------------------------------------------------------
les cl trangres sont dfinies dans dbReferences 
*******************************************************************************/
// liste des tables : commentaire, champ descriptif des enreg
/* exemple
//========= table xx
	$DIC_Table['xx']['name']="xx"; 
	$DIC_Table['xx']['comment']="xx"; 
	$DIC_Table['xx']['descField']='xx';  // array('xx', 'yy'); 
	$DIC_Table['xx']['ShortDescField']='xx'; // array('xx', 'yy'); 
	// $DIC_Table['xx']['fields']=array('xx', 'yy', 'zz'); 
	// $DIC_Table['xx']['primaryKey']='xx'; 
	$DIC_Table['xx']['requestFields']=array('xx','yy'); 
	$DIC_Table['xx']['standardOrderBy']='xx'; // array('xx', 'yy'); 
fin de l'exemple */
//========= table event
	$DIC_Table['event']['name']="incident"; 
	$DIC_Table['event']['comment']="incident"; 
	$DIC_Table['event']['descField']=array("evtNum" , "evtDate" , "evtHeure" , "classroomCode", "evtPosteNom", "useNum", "evtType", "evtDesc", "solvDate", "useNum_solve", "solvDesc", "closDate", "useNum_close" ) ;
	$DIC_Table['event']['ShortDescField']=array("evtNum" , "evtDate" , "evtHeure" , "classroomCode", "evtPosteNom", "useNum", "evtType", "evtDesc", "solvDate", "useNum_solve", "solvDesc", "closDate", "useNum_close" ) ;
	// $DIC_Table['event']['fields']=array('xx', 'yy', 'zz'); 
	// $DIC_Table['event']['primaryKey']='xx'; 
	$DIC_Table['event']['requestFields']=array("evtNum" , "evtDate" , "evtHeure" , "useNum", "evtType", "evtDesc") ;
	$DIC_Table['event']['standardOrderBy']=array("evtNum" , "evtDate" , "evtHeure") ;
//========= table user
	$DIC_Table['user']['name']="utilisateur"; 
	$DIC_Table['user']['comment']="utilisateur"; 
	$DIC_Table['user']['descField']=array("useNum" , "useNom" , "usePrenom");
	$DIC_Table['user']['ShortDescField']=array("useNom" , "usePrenom");
	// $DIC_Table['user']['fields']=array("useNum", "useNom" , "usePrenom", "useLogin", "usePwd", "useLevel");
	// $DIC_Table['user']['primaryKey']='xx'; 
	$DIC_Table['user']['requestFields']=array("useNom" , "usePrenom", "useLogin", "usePwd", "useLevel");
	$DIC_Table['user']['standardOrderBy']=array("useNom" , "usePrenom");
//========= table classroom
	$DIC_Table['classroom']['name']="Salles"; 
	$DIC_Table['classroom']['comment']="Salles"; 
	$DIC_Table['classroom']['descField']=array("classroomCode" , "classroomDesc");
	$DIC_Table['classroom']['ShortDescField']=array("classroomDesc");
	// $DIC_Table['classroom']['fields']=array('xx', 'yy', 'zz'); 
	// $DIC_Table['classroom']['primaryKey']='xx'; 
	$DIC_Table['classroom']['requestFields']=array('xx','yy'); 
	$DIC_Table['classroom']['standardOrderBy']='xx'; // array('xx', 'yy'); 
//========= table eventType
	$DIC_Table['eventType']['name']="Types d'incident"; 
	$DIC_Table['eventType']['comment']="Types d'incident"; 
	$DIC_Table['eventType']['descField']=array("evtType","evtTypeDesc");
	$DIC_Table['eventType']['ShortDescField']=array("evtTypeDesc");
	// $DIC_Table['eventType']['fields']=array('xx', 'yy', 'zz'); 
	// $DIC_Table['eventType']['primaryKey']='xx'; 
	$DIC_Table['eventType']['requestFields']=array("evtType","evtTypeDesc");
	$DIC_Table['eventType']['standardOrderBy']="evtType";
//========= table level
	$DIC_Table['level']['name']="Niveaux des utilisateurs"; 
	$DIC_Table['level']['comment']="Niveaux des utilisateurs"; 
	$DIC_Table['level']['descField']='useLevelDesc'; 
	$DIC_Table['level']['ShortDescField']='useLevel'; // array('xx', 'yy'); 
	// $DIC_Table['level']['fields']=array('xx', 'yy', 'zz'); 
	// $DIC_Table['level']['primaryKey']='xx'; 
	$DIC_Table['level']['requestFields']=array('useLevel','useLevelDesc'); 
	$DIC_Table['level']['standardOrderBy']='useLevel'; // array('xx', 'yy'); 
// liste des champs descriptif des tables
// liste des champs de description courte des tables

?>  
