<?php
// ========================================================================================
/* Cette petite application comporte deux volets : 
	a) une saisie de commande en ligne avec le remplissage puis la validation d'un panier
	b) l'afficage selon différents angles de données de logistiques : 
		cdes client, production(OF), cde frounissaure ; gammes et nomenclatures
	c) un complément permet d'afficher les clients enregistrés.
	
Cette application est une ébauche et pourrait être complétée de plusieurs fonctionnalités.
En vrac :
	- l'affichage du volume de commandes en cours pour les tiers,
	- l'affichage du stock restant, à venir (avec un délai ?),
	- l'inerdiction de metre les articles en rupture dans le panier,
	- une interface de création/modification/suppression des tiers
	- une interface de création/modification/suppression des articles
	- une interface de création/modification/suppression des données techniques
	- une interface de création/modification/suppression des autres données (paramètres : types, pays, ...)
	- la gestion des connexions utilisateurs, 
	- la saisie directe de commandes client,
	- la saisie de fabrication,
	- le calcul de planification,
	- l'ajout d'une gestion d'adresse de livraison qui pourrait être différente de celle de facturation et 
		même différente d'une commande à l'autre, pour un même client
	- la gestion de "compte client" qui éviterai de re-saisir les données de facturation (et qui pourrait être obligatoire pour passer une commande)
	
	Bref ! y en a du boulôt ...
	Soit autant de projets à réaliser par les élèves ?
*/
// ========================================================================================
include "library/_gesComDesign.inc.php";
include "library/install.inc.php";
// ========================================================================================
// FONCTIONS LOCALES
// ========================================================================================
// cette fonction doit être déclarée, même vide car elle est appelée dans _pageHeader() mais n'y est pas définie
// car elle est propre à chaque page. elle sert à remplir la colonne de droite pour créer un menu contextuel
function _menuRight(){}

// ========================================================================================
// MAIN()
// ========================================================================================
$userId="";
_pageHeader($userId);	// entête de page et menu
?>
<br> 
<table width='80%' cellspacing='0' cellpadding='0' align='center'>
	<tr><td colspan='100%'>
		Cette application web a pour rôle de fournir un environnement électronique d'entraînement pour la terminale SIG.
		<br>Elle offre une simmulation :
		<ul><li>d'achats en ligne et</li><li> de gestion de production.</li></ul>
		<br>
		<br>
<?php
include ("config/dbCfg.inc.php");
$connexion=mysql_connect($hote,$login,$mdp);

if (chk_install()>2){
?>
		<ul>
			<li><a href='erpArtLst.php'>Aller du coté Gestion de production (back office)</a></li>
			<li><a href='cdeArtLst.php'>Aller du coté achats en ligne (front office)</a></li>
		</ul>

<?php
}else{
	do_install();
}
?>
	</td></tr>
</table>
<?php
_pageFooter(); // pied de page

/* poubelle de code =======================================================================
$opts['fdd']['telephone'] = array(
  'name'     => 'Telephone',
  'colDesc'  => 'Téléphone',
  'select'   => 'T',
  'maxlen'   => 20,
  'required' => true,
  'sort'     => true
);
*/
?>
